## bash 5.3

=== debian/changelog ===
bash (5.3-1ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable (LP: #2130157). Remaining changes:
    - d/skel.bashrc: run lesspipe
    - d/skel.bashrc: enable ls aliases
    - d/skel.bashrc: set options in ll alias to -alF
    - d/skel.bashrc: define an alert alias
    - d/skel.bashrc: enable colored grep aliases
    - d/p/deb-bash-config.diff: resurrect "Set the default
      path to comply with Debian policy"
    - d/tests: add autopkgtest for the built-in path
    - d/rules: change SHELL to /usr/bin/bash
    Drop changes cancelling each other:
    - d/etc.bash.bashrc: add sudo hint
    - remove bash hint from /etc/bash.bashrc
    Drop changes addressed in Debian:
    - Source profile.d from /etc/bash.bashrc to allow packages to ship
      integration hooks into interactive shells, same ones they already ship
      for login shells (Closes #675008) (LP #2083705)
    - Undo the change from the last upload, but keep the code commented
      out.  This should be at a user's discretion.  And there are already
      explicit hooks for bash-completion and command-not-found.
    - /etc/bash.bashrc: Explicitly source /etc/profile.d/vte*.sh, and
      sync the color prompt setting from /etc/skel/.bashrc.
    Drop changes addressed upstream:
    - d/p/fix-rcfile-man.diff: correct the bash(1) man-page
    Drop temporary changes:
    - temporarily set std=gnu17 to fix the FTBFS

 -- Nadzeya Hutsko <nadzeya.hutsko@canonical.com>  Thu, 30 Oct 2025 18:02:26 +0100

bash (5.3-1) unstable; urgency=medium

  * New upstream release 5.3.
  * Apply upstream patches 001 - 003.
  * clear_console: Handle screen and screen.* TERM envvar.
  * bashrc: Avoid a command-not-found lookup stat (Ville Skyttä).
    Closes: #1015216.

 -- Matthias Klose <doko@debian.org>  Wed, 03 Sep 2025 10:39:11 +0200

bash (5.2.37-2ubuntu5) questing; urgency=medium

  * Dropping delta not considered relevant any more (LP: #2120249)
    - d/etc.bash.bashrc: add sudo hint
  * Temporarily set -std=gnu17 to fix FTBFS with gcc-15
    - https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1098911

 -- Ravi Kant Sharma <ravi.kant.sharma@canonical.com>  Mon, 08 Sep 2025 15:20:42 +0200

bash (5.2.37-2ubuntu4) questing; urgency=medium

  * /etc/bash.bashrc: Explicitly source /etc/profile.d/vte*.sh, and
    sync the color prompt setting from /etc/skel/.bashrc.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 16 Jun 2025 19:54:28 +0200

bash (5.2.37-2ubuntu3) questing; urgency=medium

  * Undo the change from the last upload, but keep the code commented
    out.  This should be at a user's discretion.  And there are already
    explicit hooks for bash-completion and command-not-found.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 11 Jun 2025 10:48:05 +0200

bash (5.2.37-2ubuntu2) questing; urgency=medium

  [ Dimitri John Ledkov ]
  * Source profile.d from /etc/bash.bashrc to allow packages to ship
    integration hooks into interactive shells, same ones they already ship
    for login shells (Closes: #675008) (LP: #2083705)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 10 Jun 2025 21:09:39 -0400

bash (5.2.37-2ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2111514). Remaining changes:
    - d/skel.bashrc:
      + run lesspipe
      + enable ls aliases
      + set options in ll alias to -alF
      + define an alert alias
      + enable colored grep aliases
    - d/etc.bash.bashrc: add sudo hint
    - d/p/deb-bash-config.diff: resurrect "Set the default path to comply with Debian policy"
    - d/tests: add autopkgtest for the built-in path
    - d/p/fix-rcfile-man.diff: correct the bash(1) man-page
      + Add a note that --rcfile does not prevent the execution of the
        system-wide /etc/bash.bashrc file.

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Tue, 20 May 2025 21:19:03 -0700

=== debian/control ===
Source: bash
Section: base
Priority: required
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
Standards-Version: 4.7.2
Build-Depends: autoconf, autotools-dev, bison, libncurses5-dev,
 texinfo, texi2html, debhelper (>= 11), gettext, sharutils,
 locales <!nocheck>, time <!nocheck>,
 xz-utils,
Build-Depends-Indep: texlive-latex-base, ghostscript, texlive-fonts-recommended, man2html-base
Build-Conflicts: r-base-core
Homepage: http://tiswww.case.edu/php/chet/bash/bashtop.html
#Vcs-Browser: https://code.launchpad.net/~doko/+junk/pkg-bash-debian
#Vcs-Bzr: http://bazaar.launchpad.net/~doko/+junk/pkg-bash-debian
Rules-Requires-Root: binary-targets

Package: bash
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${shlibs:Pre-Depends}, ${misc:Depends}
Depends: base-files (>= 2.1.12), debianutils (>= 5.6-0.1)
Recommends: bash-completion
Suggests: bash-doc
Essential: yes
Section: shells
Priority: required
Description: GNU Bourne Again SHell
 Bash is an sh-compatible command language interpreter that executes
 commands read from the standard input or from a file.  Bash also
 incorporates useful features from the Korn and C shells (ksh and csh).
 .
 Bash is ultimately intended to be a conformant implementation of the
 IEEE POSIX Shell and Tools specification (IEEE Working Group 1003.2).
 .
 The Programmable Completion Code, by Ian Macdonald, is now found in
 the bash-completion package.

Package: bash-static
Architecture: any
Multi-Arch: foreign
Depends: passwd (>= 1:4.0.3-10), debianutils (>= 5.6-0.1), ${misc:Depends}
Suggests: bash-doc
Section: shells
Priority: optional
Built-Using: ${glibc:Source}
Description: GNU Bourne Again SHell (static version)
 Bash is an sh-compatible command language interpreter that executes
 commands read from the standard input or from a file.  Bash also
 incorporates useful features from the Korn and C shells (ksh and csh).
 .
 Statically linked.

Package: bash-builtins
Architecture: any
Depends: bash (= ${binary:Version}), ${misc:Depends}
Section: utils
Priority: optional
Description: Bash loadable builtins - headers & examples
 Bash can dynamically load new builtin commands.  Included are the
 necessary headers to compile your own builtins and lots of examples.

Package: bash-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Priority: optional
Replaces: bash (<< 4.3-2)
Description: Documentation and examples for the GNU Bourne Again SHell
 Bash is an sh-compatible command language interpreter that executes
 commands read from the standard input or from a file.  Bash also
 incorporates useful features from the Korn and C shells (ksh and csh).
 .
 This package contains the distributable documentation, all the
 examples and the main changelog.

=== debian/rules ===
#! /usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES

# architecture dependent variables
vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS := $(shell dpkg-architecture)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_CPU	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_CPU)
DEB_HOST_GNU_SYSTEM	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_SYSTEM)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

VERSION		:= 4.2
#PKGVERSION	:= $(shell dpkg-parsechangelog \
#			| sed -n '/Version:/s/\(.* \)\(.*\)-2\(.*\)/\2\3/p')
#PKGVERSION	:= 3.0
#dpkg_ctrl_args := -v$(PKGVERSION) -VBinary-Version=$(PKGVERSION)

with_gfdl	= yes

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  CC	= $(DEB_HOST_GNU_TYPE)-gcc
else
  CC	= gcc
endif

ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
  STRIP = :
else
  ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
    STRIP = $(DEB_HOST_GNU_TYPE)-strip
  else
    STRIP = strip
  endif
endif


dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS="hardening=+all" DEB_CFLAGS_MAINT_APPEND="-Wall" dpkg-buildflags
CFLAGS := $(shell $(dpkg_buildflags) --get CFLAGS)
CPPFLAGS := $(shell $(dpkg_buildflags) --get CPPFLAGS)
LDFLAGS := $(shell $(dpkg_buildflags) --get LDFLAGS)

SHELL	= /usr/bin/bash
YACC	= bison -y

IX	= install -o 0 -g 0
ID	= install -o 0 -g 0 -m 644

# built with installed libreadline?
with_installed_rl = no

debflags =

p	= bash
p_stat	= bash-static
p_bins	= bash-builtins
p_doc	= bash-doc

d	= debian/$(p)
d_stat	= debian/$(p_stat)
d_bins	= debian/$(p_bins)
d_doc	= debian/$(p_doc)

termcap_lib := $(if $(wildcard /usr/lib/libtinfo.so /usr/lib/$(DEB_HOST_MULTIARCH)/libtinfo.so), \
		 -ltinfo, \
		 -lncurses)

conf_args = \
	--enable-largefile \
	--prefix=/usr \
	--infodir=/usr/share/info \
	--mandir=/usr/share/man \
	--without-bash-malloc
ifeq ($(with_installed_rl),yes)
    conf_args += --with-installed-readline
endif
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
    conf_args += --build $(DEB_HOST_GNU_TYPE)
else
    conf_args += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

static_conf_args := $(conf_args) \
	--enable-static-link \

#build: bash-build static-build check
build: stamps/before-build bash-build static-build check
build-arch: build
build-indep: build

stamps/before-build:
	dh_testdir
#	dh_update_autotools_config
	dh_autotools-dev_updateconfig
	mkdir -p stamps
	: # see #327477, needed to have HAVE_DEV_STDIN defined
	(test -d /dev/fd && test -r /dev/stdin < /dev/null) \
	  || (test -d /proc/self/fd && test -r /dev/stdin < /dev/null)
ifneq (,$(findstring $(DEB_HOST_ARCH_OS), linux freebsd))
	$(CC) $(CFLAGS) $(LDFLAGS) $(CPPFLAGS) -o clear_console \
	    debian/clear_console.c $(termcap_lib)
endif
	touch $@

# ---------------------------------------------------------------------------
# build standard bash

bash-build:
	$(MAKE) -f debian/rules do-build-bash \
	    bash_src=. \
	    build=bash \
	    configure_args="$(conf_args)"
bash-configure: stamps/before-build
	$(MAKE) -f debian/rules do-configure-bash \
	    bash_src=. \
	    build=bash \
	    configure_args="$(conf_args)"

# ---------------------------------------------------------------------------
# build static bash

static-build:
	$(MAKE) -f debian/rules do-build-static \
	    bash_src=. \
	    build=static \
	    configure_args="$(static_conf_args)"
static-configure: stamps/before-build
	$(MAKE) -f debian/rules do-configure-static \
	    bash_src=. \
	    build=static \
	    configure_args="$(static_conf_args)"

# ---------------------------------------------------------------------------

bash-doc-build: stamps/stamp-build-bash-doc
stamps/stamp-build-bash-doc:
	rm -f bash/doc/bashref.info
	$(MAKE) -C build-bash/doc info html MAN2HTML=/usr/bin/man2html
	$(MAKE) -C build-bash/doc bash.pdf bashref.pdf
	touch stamps/stamp-build-bash-doc

# ---------------------------------------------------------------------------

check: stamps/stamp-check
stamps/stamp-check: bash-build
	@echo BEGIN test
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
  ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	-sh debian/locale-gen
	LOCPATH=$(CURDIR)/locales \
		time $(MAKE) -C build-bash test 2>&1 | tee build-bash/test-protocol
  endif
else
	@echo Suppress 'make' test, because this is cross build
endif
	@echo END test
	touch stamps/stamp-check

# ---------------------------------------------------------------------------

clean:
	dh_testdir
	dh_testroot
	rm -rf stamps build-*
	rm -f debian/README.Debian
	rm -rf locales
	rm -f clear_console
	dh_autotools-dev_restoreconfig
	dh_clean

# ---------------------------------------------------------------------------


install: bash-install

bash-install: bash-build stamps/stamp-install-bash
stamps/stamp-install-bash: stamps/before-build stamps/stamp-build-bash
	dh_testdir
	dh_testroot
	dh_prep -p$(p) -p$(p_doc) -p$(p_bins)
	dh_installdirs -p$(p) \
		usr/bin \
		etc/skel \
		usr/share/doc/$(p)
	dh_installdirs -p$(p_doc) \
		usr/share/doc/$(p)
	dh_installdirs -p$(p_bins) \
		usr/share/doc/$(p)/examples/loadables

ifeq ($(with_gfdl),yes)
# XXXXX
#	cp -p build-bash/doc/*.info bash/doc/
endif

	: # install it
	$(MAKE) -C build-bash install \
		YACC="$(YACC)" \
		DESTDIR=$(CURDIR)/$(d)
	chmod 755 $(d)/usr/bin/bashbug
	$(ID) debian/bashbug.1 $(d)/usr/share/man/man1/
ifneq ($(with_gfdl),yes)
	mkdir -p $(d)/usr/share/man/man1
	cp -p bash/doc/bash.1 $(d)/usr/share/man/man1/bash.1
endif
	rm -f $(d)/usr/share/doc/bash/*.html
	rm -f $(d)/usr/share/info/*.info
	rm -f $(d)/usr/share/info/dir*

	: # extra links
	ln -sf bash $(d)/usr/bin/rbash

	: # skeleton files
	$(ID) debian/etc.bash.bashrc $(d)/etc/bash.bashrc
	$(ID) debian/skel.bashrc $(d)/etc/skel/.bashrc
	$(ID) debian/skel.profile $(d)/etc/skel/.profile
	$(ID) debian/skel.bash_logout $(d)/etc/skel/.bash_logout

	: # clean_console
ifneq (,$(findstring $(DEB_HOST_ARCH_OS), linux freebsd))
	$(IX) clear_console $(d)/usr/bin/
	$(ID) debian/clear_console.1 $(d)/usr/share/man/man1/
endif

	: # /etc/shells integration
	$(ID) -D debian/shells.d/bash $(d)/usr/share/debianutils/shells.d/bash

	: # files for the bash-doc package

	dh_installexamples -p$(p_doc) examples/*
	rm -rf $(d_doc)/usr/share/doc/$(p)/examples/loadables
	mkdir -p $(d_doc)/usr/share/doc/$(p_doc)
	ln -sf ../$(p)/examples $(d_doc)/usr/share/doc/$(p_doc)/examples

	rm -rf $(d_doc)/usr/share/doc/$(p)/examples/obashdb
	cd $(d_doc)/usr/share/doc/$(p)/examples && chmod 755 \
		misc/aliasconv.*sh misc/cshtobash

	cd $(d_doc)/usr/share/doc/$(p)/examples && chmod 644 \
		scripts/shprompt

	: # files for the bash-builtins package
	mv $(d)/usr/include $(d_bins)/usr/.
	mv $(d)/usr/lib $(d_bins)/usr/.
	$(ID) examples/loadables/{README,*.c} \
		$(d_bins)/usr/share/doc/$(p)/examples/loadables
	$(ID) build-bash/examples/loadables/Makefile \
		$(d_bins)/usr/share/doc/$(p)/examples/loadables
	ln -sf bash $(d_bins)/usr/share/doc/$(p_bins)

	sed -i \
		-e 's@-ffile-prefix-map=[^ ]*[ ]*@@g' \
		-e 's@-fdebug-prefix-map=[^ ]*[ ]*@@g' \
		-e 's@^BUILD_DIR =.*@BUILD_DIR = /path/to/build-dir@' \
		$(d)/usr/bin/bashbug \
		$(d_bins)/usr/lib/bash/Makefile.inc \
		$(d_bins)/usr/share/doc/$(p)/examples/loadables/Makefile

#	cat debian/README stamps/stamp-patch > debian/README.Debian
	cat debian/README > debian/README.Debian

	touch stamps/stamp-install-bash

binary-doc: bash-install bash-doc-build
	dh_testdir
	dh_testroot
	mkdir -p $(d_doc)/usr/share/doc/$(p)
ifeq ($(with_gfdl),yes)
	dh_installdocs -p$(p_doc) 
	cp -p build-bash/doc/bashref.{html,pdf} $(d_doc)/usr/share/doc/$(p)/.
	mkdir -p $(d_doc)/usr/share/info
	cp -p build-bash/doc/bash.info $(d_doc)/usr/share/info/.
	dh_link -p$(p_doc) \

=== debian/tests/control ===
Tests: builtin-path.sh
Depends: bash

## bash kernel-0.9.3

=== binder/requirements.txt ===
bash_kernel

## bash quote-1.0.1

=== requirements.txt ===
beautifulsoup4>=4.3.0
requests>=2.0.0

## bash test

=== pidlist_test/Makefile ===
all:
	strace -tf ./check_db_main.sh 2>strace-log.txt

clean:
	rm -f *.txt

## bash workbench-0.0.15

=== requirements.txt ===
argcomplete
gitpython
importlib_resources
pyyaml
questionary
